﻿using System;
using System.Collections.Generic;
using System.Text;

namespace CY.SDK.Ambry
{
    class Headers
    {
        // general headers
        /**
         * {@code "Cache-Control"}
         */
        public   const String CACHE_CONTROL = "Cache-Control";
        /**
         * {@code "Content-Length"}
         */
        public const String CONTENT_LENGTH = "Content-Length";
        /**
         * {@code "Content-Type"}
         */
        public const String CONTENT_TYPE = "Content-Type";
        /**
         * {@code "Date"}
         */
        public const String DATE = "Date";
        /**
         * {@code "Expires"}
         */
        public const String EXPIRES = "Expires";
        /**
         * {@code "Last-Modified"}
         */
        public const String LAST_MODIFIED = "Last-Modified";
        /**
         * {@code "Location"}
         */
        public const String LOCATION = "Location";
        /**
         * {@code "Pragma"}
         */
        public const String PRAGMA = "Pragma";

        // ambry specific headers
        /**
         * mandatory in request; long; size of blob in bytes
         */
        public const String BLOB_SIZE = "x-ambry-blob-size";
        /**
         * mandatory in request; string; name of service
         */
        public const String SERVICE_ID = "x-ambry-service-id";
        /**
         * optional in request; date string; default unset ("infinite ttl")
         */
        public const String TTL = "x-ambry-ttl";
        /**
         * optional in request; 'true' or 'false' case insensitive; default 'false'; indicates private content
         */
        public const String PRIVATE = "x-ambry-private";
        /**
         * mandatory in request; string; default unset; content type of blob
         */
        public const String AMBRY_CONTENT_TYPE = "x-ambry-content-type";
        /**
         * optional in request; string; default unset; member id.
         * <p/>
         * Expected usage is to set to member id of content owner.
         */
        public const String OWNER_ID = "x-ambry-owner-id";
        /**
         * not allowed  in request. Allowed in response only; string; time at which blob was created.
         */
        public const String CREATION_TIME = "x-ambry-creation-time";
        /**
         * prefix for any header to be set as user metadata for the given blob
         */
        public const String USER_META_DATA_HEADER_PREFIX = "x-ambry-um-";

        /**
         * Header to contain the Cookies
         */
        public const String COOKIE = "Cookie";
        /**
         * Header to be set by the clients during a Get blob call to denote, that blob should be served only if the blob
         * has been modified after the value set for this header.
         */
        public const String IF_MODIFIED_SINCE = "If-Modified-Since";
    }
}
