﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.IO;
using System.Web;
using System.Net.Http;
using System.Net.Http.Headers;

namespace CY.SDK.Ambry
{
    partial class HttpHelper
    {
        static HttpClient client = new HttpClient();

        public static HttpReponse PostWebRequest(string postUrl, byte[] content, Dictionary<string, string> headers = null)
        {
            HttpReponse postRes = new HttpReponse();
            string ret = string.Empty;

            //string val = System.Web.HttpContext.Current.Server.UrlEncode(paramData.ToString().TrimEnd('&'));
            Encoding myEncoding = Encoding.UTF8;
            byte[] byteArray = content; //转化

            HttpContent context = new ByteArrayContent(byteArray);


            if (headers != null)
            {
                foreach (KeyValuePair<string, string> header in headers)
                {
                    context.Headers.Add(header.Key, header.Value);
                }
            }

            var message = client.PostAsync(postUrl, context).Result;
            if (!message.IsSuccessStatusCode)
            {
                throw new Exception("上传OSS失败");
            }
            ret = message.Content.ReadAsStringAsync().Result;

            //message.Headers  = HttpResponseHeaders
            //message.Content.Headers =HttpContentHeaders
            postRes.Headers = message.Headers;


            postRes.Result = ret;
            return postRes;



        }




        public static HttpFileReponse GetFileRequest(string postUrl)
        {
            HttpFileReponse res = new HttpFileReponse();




            var message = client.GetAsync(postUrl).Result;
            if (!message.IsSuccessStatusCode)
            {
                throw new Exception("获取OSS失败");
            }

            // string ret = message.Content.ReadAsStringAsync().Result;
            res.Headers = message.Headers;

            var stream = message.Content.ReadAsStreamAsync().Result;
            MemoryStream mem = new MemoryStream((int)stream.Length);// stream.CopyTo(stream);
            stream.CopyTo(mem);
            res.Stream = mem;
            res.Bytes = mem.ToArray();
            res.ContentType = message.Content.Headers.ContentType.ToString();
            return res;



        }



        public static HttpReponse GetRequest(string postUrl)
        {
            HttpReponse res = new HttpReponse();




            var message = client.GetAsync(postUrl).Result;
            if (!message.IsSuccessStatusCode)
            {
                throw new Exception("获取OSS失败");
            }
            // string ret = message.Content.ReadAsStringAsync().Result;
            res.Headers = message.Headers;
            res.Result = message.Content.ReadAsStringAsync().Result;
            return res;


        }


    }

    public class HttpReponse
    {
        public string Result { set; get; }
        public HttpResponseHeaders Headers { set; get; }

    }

    public class HttpFileReponse
    {
        public string Result { set; get; }
        public HttpResponseHeaders Headers { set; get; }
        public MemoryStream Stream { set; get; }

        public byte[] Bytes { set; get; }

        public string ContentType { set; get; }

    }

}
