﻿using System;
using System.Collections.Generic;
using System.Net;
using System.Text;
using CY.SDK.Ambry.Response;

namespace CY.SDK.Ambry.Request
{
    public class PostFileRequest : BaseRequest<PostFileResponse>
    {
        public override PostFileResponse Excete(string url)
        {
            PostFileResponse response = new PostFileResponse() { IsError = false, };
            try
            {
                Dictionary<string, string> header = GenerateHeaders();
                HttpReponse res = HttpHelper.PostWebRequest(url, FileContent, header);


                /**
                    res.Headers.Keys[0]
"Location"
res.Headers.Keys[1]
"Date"
res.Headers.Keys[2]
"x-ambry-creation-time"
res.Headers.Keys[3]
"Content-Length"
                 */
                //Location: /AAEAAQAAAAAAAAAAAAAAJDE5OTE4MTFhLWU3MDYtNDk2NS05ZGI0LTExY2RkZTUwNmU1MA\r\n
                //Date: Mon, 06 May 2019 03:36:05 GMT\r\n
                //x-ambry-creation-time: Mon, 06 May 2019 03:36:05 GMT\r\n
             

                response.FilePath = res.Headers.Location.OriginalString;
                response.AmbryId = res.Headers.Location.OriginalString.TrimStart('/');
                response.ContentLength = "1"; //res.NewHeaders[Headers.CONTENT_LENGTH];
                response.Date = Convert.ToDateTime(res.Headers.Date.Value.ToLocalTime().ToString("yyyy-MM-dd HH:mm:ss"));
                response.AmbryCreationTime = Convert.ToDateTime(res.Headers.Date.Value.ToLocalTime().ToString("yyyy-MM-dd HH:mm:ss"));



                response.Body = res.Result;
            }
            catch (Exception ex)
            {
                response.IsError = true;
                response.ErrorMsg = ex.Message;
            }
            return response;
        }

        /// <summary>
        /// ex: image/gif
        /// </summary>
        public string FileType { set; get; }
        public byte[] FileContent { set; get; }

        public override string GetPath()
        {
            return "";//mo默认路径为空
        }


        private Dictionary<string, string> GenerateHeaders()
        {
            Dictionary<string, string> headers = new Dictionary<string, string>();
            headers.Add(Headers.BLOB_SIZE, FileContent.Length + "");
            headers.Add(Headers.SERVICE_ID, "ambry-client");
            headers.Add(Headers.AMBRY_CONTENT_TYPE, FileType);
            return headers;
        }
    }
}
